"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.determineAction = void 0;
var error_1 = __importDefault(require("../../error"));
var determineAction = function (action) {
    switch (action.ifParsingFailThen) {
        case 'get': {
            return action.alternativeValue;
        }
        case 'lazy-get': {
            return action.alternativeValue();
        }
        case 'throw': {
            throw action.message instanceof Error
                ? action.message
                : error_1["default"].fromMessage(action.message);
        }
    }
};
exports.determineAction = determineAction;
//# sourceMappingURL=action.js.map