import Parser from '../class/abstract';
import { Get, LazyGet, Throw } from '../function/action';
declare type CustomPredicate = Readonly<{
    value: any;
    predicate: (value: any) => boolean;
}>;
declare function parseAsCustom<C, E extends Error>(options: Throw<E> & CustomPredicate): C;
declare function parseAsCustom<C, T>(options: (Get<T> | LazyGet<T>) & CustomPredicate): T | C;
declare class CustomParser<C = any> extends Parser<C> {
    private readonly predicate;
    constructor(value: any, predicate: CustomPredicate['predicate']);
    elseGet: <A>(alternativeValue: A) => C | A;
    elseLazyGet: <A>(alternativeValue: () => A) => C | A;
    elseThrow: <E extends Error>(message: string | E) => C;
}
export { parseAsCustom, CustomParser };
