declare type Throw<E extends Error> = Readonly<{
    message: E | string;
    ifParsingFailThen: 'throw';
}>;
declare type Get<T> = Readonly<{
    alternativeValue: T;
    ifParsingFailThen: 'get';
}>;
declare type LazyGet<T> = Readonly<{
    alternativeValue: () => T;
    ifParsingFailThen: 'lazy-get';
}>;
declare type Action<T, E extends Error> = Throw<E> | Get<T> | LazyGet<T>;
declare const determineAction: <T, E extends Error>(action: Action<T, E>) => T;
export { determineAction };
export { Throw, Get, Action, LazyGet };
