import Parser from '../class/abstract';
import { Get, LazyGet, Throw } from '../function/action';
declare type N = null;
declare type NullOptions = Readonly<{
    value: unknown;
}>;
declare function parseAsNull<E extends Error>(options: Throw<E> & NullOptions): null;
declare function parseAsNull<T>(options: Get<T> & NullOptions): T | null;
declare function parseAsNull<T>(options: LazyGet<T> & NullOptions): T | null;
declare class NullParser extends Parser<N> {
    constructor(value: any);
    elseGet: <A>(alternativeValue: A) => A | null;
    elseLazyGet: <A>(alternativeValue: () => A) => A | null;
    elseThrow: <E extends Error>(message: string | E) => N;
}
export { NullParser, parseAsNull };
