import ParserError from '../../error/index.js';
const determineAction = (action) => {
    switch (action.ifParsingFailThen) {
        case 'get': {
            return action.alternativeValue;
        }
        case 'lazy-get': {
            return action.alternativeValue();
        }
        case 'throw': {
            throw action.message instanceof Error
                ? action.message
                : ParserError.fromMessage(action.message);
        }
    }
};
export { determineAction };
//# sourceMappingURL=action.js.map