import Parser from '../class/abstract.js';
import { determineAction, } from '../function/action.js';
import { inRangeOf, isInRangeOf } from '../helper/index.js';
function parseAsNumber(options) {
    if (typeof options.number !== 'number') {
        return determineAction(options);
    }
    const { number } = options;
    if (!options.inRangeOf) {
        return number;
    }
    return isInRangeOf({
        ...inRangeOf(options.inRangeOf),
        value: number,
    })
        ? number
        : determineAction(options);
}
class NumberParser extends Parser {
    range;
    constructor(value) {
        super(value);
    }
    inRangeOf = (rangeOf) => {
        this.range = inRangeOf(rangeOf);
        return this;
    };
    elseThrow = (message) => parseAsNumber({
        message,
        number: this.value,
        inRangeOf: this.range,
        ifParsingFailThen: 'throw',
    });
    elseGet = (alternativeValue) => parseAsNumber({
        alternativeValue,
        number: this.value,
        inRangeOf: this.range,
        ifParsingFailThen: 'get',
    });
    elseLazyGet = (alternativeValue) => parseAsNumber({
        alternativeValue,
        number: this.value,
        inRangeOf: this.range,
        ifParsingFailThen: 'lazy-get',
    });
}
export { NumberParser, parseAsNumber };
//# sourceMappingURL=number.js.map